set spark.scheduler.session.priority=true;

use ${DB};

-- ============================================================
--   Table: income_band
-- ============================================================
drop table if exists income_band;
create table income_band
using parquet OPTIONS(parquet.compression "SNAPPY", parquet.enable.dictionary "false", parquet.writer.version "v2")
TBLPROPERTIES("transactional"="true")
as select * from ${SOURCE}.income_band;

ANALYZE TABLE income_band COMPUTE STATISTICS FOR COLUMNS ib_income_band_sk, ib_lower_bound, ib_upper_bound;
