set spark.scheduler.session.priority=true;

use ${DB};

-- ============================================================
--   Table: reason
-- ============================================================
drop table if exists reason;
create table reason
using parquet OPTIONS(parquet.compression "SNAPPY", parquet.enable.dictionary "false", parquet.writer.version "v2")
TBLPROPERTIES("transactional"="true")
as select * from ${SOURCE}.reason;

ANALYZE TABLE reason COMPUTE STATISTICS FOR COLUMNS r_reason_sk, r_reason_id, r_reason_desc;
