set spark.scheduler.session.priority=true;

use ${DB};

-- ============================================================
--   Table: time_dim
-- ============================================================
drop table if exists time_dim;
create table time_dim
using parquet OPTIONS(parquet.compression "SNAPPY", parquet.enable.dictionary "false", parquet.writer.version "v2")
TBLPROPERTIES("transactional"="true")
as select * from ${SOURCE}.time_dim;

ANALYZE TABLE time_dim COMPUTE STATISTICS FOR COLUMNS t_time_sk, t_time_id, t_time, t_hour, t_minute, t_second, t_am_pm, t_shift, t_sub_shift, t_meal_time;
