set spark.scheduler.session.priority=true;

use ${DB};

-- ============================================================
--   Table: ship_mode
-- ============================================================
drop table if exists ship_mode;
create table ship_mode
using parquet OPTIONS(parquet.compression "SNAPPY", parquet.enable.dictionary "false", parquet.writer.version "v2")
TBLPROPERTIES("transactional"="true")
as select * from ${SOURCE}.ship_mode;

ANALYZE TABLE ship_mode COMPUTE STATISTICS FOR COLUMNS sm_ship_mode_sk, sm_ship_mode_id, sm_type, sm_code, sm_carrier, sm_contract;
