#!/bin/bash
set -e

source config

LOG=${LOG_DIR}/mt_$1.log
> $LOG # clear the log

export JAVA_TOOL_OPTIONS=-Djline.terminal=jline.UnsupportedTerminal

log info "Maintenance test $1 started." | tee -a $LOG 2>&1

if [ $1 -ne 2 ]; then
  ./run_refresh.sh 1 | tee -a $LOG 2>&1
  ./run_refresh.sh 2 | tee -a $LOG 2>&1
else
  ./run_refresh.sh 3 | tee -a $LOG 2>&1
  ./run_refresh.sh 4 | tee -a $LOG 2>&1
fi

log info "Maintenance test $1 finished." | tee -a $LOG 2>&1
